Index: util/dtc/flattree.c
===================================================================
--- util/dtc/flattree.c	(revision 364)
+++ util/dtc/flattree.c	(working copy)
@@ -640,7 +640,26 @@
 
 }
 
-	
+static void flatten_tree_emit_constructors(struct node *tree, struct emitter *emit,
+			 void *etarget, struct data *strbuf,
+			 struct version_info *vi)
+{
+	struct property *prop;
+	struct node *child;
+	/* find any/all properties with the name constructor */
+	for_each_property(tree, prop) {
+		if (streq(prop->name, "constructor")){
+			printf("\t%s,\n", prop->val.val);
+		}
+	}
+
+	for_each_child(tree, child) {
+		flatten_tree_emit_constructors(child, emit, etarget, strbuf, vi);
+	}
+
+
+}
+
 static void flatten_tree_emit_structdecls(struct node *tree, struct emitter *emit,
 			 void *etarget, struct data *strbuf,
 			 struct version_info *vi)
@@ -1222,6 +1241,9 @@
 
 	flatten_tree_emit_structdecls(bi->dt, &linuxbios_emitter, f, &strbuf, vi);
 	flatten_tree_emit_structinits(bi->dt, &linuxbios_emitter, f, &strbuf, vi);
+	fprintf(f, "struct constructor *all_constructors[] = {\n");
+	flatten_tree_emit_constructors(bi->dt, &linuxbios_emitter, f, &strbuf, vi);
+	fprintf(f, "\t0\n};\n");
 	data_free(strbuf);
 	/* */
 
